"{ Package: 'cvut:stx/goodies/libsvn' }"

"{ NameSpace: SVN }"

BranchCommand subclass:#LogCommand
	instanceVariableNames:'path'
	classVariableNames:''
	poolDictionaries:''
	category:'SVN-Private-Commands'
!


!LogCommand methodsFor:'accessing'!

path
    ^ path
!

path:aString
    path := aString.
! !

!LogCommand methodsFor:'executing - private'!

svnCmd
    "raise an error: must be redefined in concrete subclass(es)"

    ^'log'

    "Created: / 11-04-2008 / 13:25:11 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

svnCmdArgumentsOn: args 
    args
        nextPut: '--verbose';
        nextPut: '--xml';
        nextPut: self url , '/' , path

    "Created: / 11-04-2008 / 13:25:04 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 19-08-2009 / 10:02:30 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

svnParseXML: doc 
    ^ (doc root / 'logentry') asCollection 
        collect: [:entryNode | RevisionLogEntry readFromXml: entryNode ]

    "Created: / 11-04-2008 / 13:26:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 19-04-2008 / 18:48:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

svnProcessCommandOutput:out err:err 
    ^ self svnParseXML:((XML::XMLParser on:out)
                validate:false;
                scanDocument)

    "Created: / 03-10-2008 / 16:31:45 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!LogCommand class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
!

version_SVN
    ^'Id: SVN__LogCommand.st 110 2009-08-19 13:21:10Z vranyj1 '
! !
